/**
 * Z PL/SQL Analyzer
 * Copyright (C) 2015-2023 Felipe Zorzo
 * mailto:felipe AT felipezorzo DOT com DOT br
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
package org.sonar.plsqlopen.rules

class Repository(override val key: String) : ZpaRepository {

    private val rules = mutableMapOf<String, ZpaRule>()

    override fun createRule(ruleKey: String): ZpaRule {
        val rule = Rule(ruleKey)
        rules[ruleKey] = rule
        return rule
    }

    override fun rule(ruleKey: String): ZpaRule? = rules[ruleKey]

    val availableRules: List<ZpaRule>
        get() = rules.values.toList()

    override fun toString(): String = key

}
